| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
StatusCodeSvc Class Reference

`#include <src/StatusCodeSvc.h>`

Inheritance diagram for StatusCodeSvc:
[legend]
Collaboration diagram for StatusCodeSvc:
[legend]

## Classes
struct | StatCodeDat

## Public Member Functions
StatusCode | initialize () override
StatusCode | reinitialize () override
StatusCode | finalize () override
void | regFnc (const std::string &func, const std::string &lib) override
void | list () const override
bool | suppressCheck () const override
Public Member Functions inherited from extends< Service, IStatusCodeSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Private Member Functions
void | parseFilter (const std::string &str, std::string &fnc, std::string &lib) const
bool | failsFilter (const std::string &fnc, const std::string &lib) const

## Private Attributes
Gaudi::Property< std::vector< std::string > > | m_pFilter {this, "Filter"}
Gaudi::Property< bool > | m_abort {this, "AbortOnError", false}
Gaudi::Property< bool > | m_suppress {this, "SuppressCheck", false}
Gaudi::Property< bool > | m_dict {this, "IgnoreDicts", true}
tbb::concurrent_unordered_map< std::string, StatCodeDat > | m_dat
std::set< std::string > | m_filterfnc
std::set< std::string > | m_filterlib

## Additional Inherited Members
Public Types inherited from extends< Service, IStatusCodeSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 12 of file StatusCodeSvc.h.

## Member Function Documentation

## ◆ failsFilter()

bool StatusCodeSvc::failsFilter | ( | const std::string & | fnc,
|  | const std::string & | lib
| ) |  | const
| private

Definition at line 93 of file StatusCodeSvc.cpp.

93 {
94 return m_filterfnc.find( fnc ) != m_filterfnc.end() || m_filterlib.find( lib ) != m_filterlib.end();
95 }
std::set::end
T end(T... args)
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:43
std::set::find
T find(T... args)
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:43

## ◆ finalize()

StatusCode StatusCodeSvc::finalize | ( |  | ) |
| override

Definition at line 38 of file StatusCodeSvc.cpp.

38 {
39
40 list();
41 return StatusCode::SUCCESS;
42 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
StatusCodeSvc::list
void list() const override
Definition: StatusCodeSvc.cpp:99

## ◆ initialize()

StatusCode StatusCodeSvc::initialize | ( |  | ) |
| override

Definition at line 11 of file StatusCodeSvc.cpp.

11 {
12
13 StatusCode sc = Service::initialize();
14 if ( !sc.isSuccess() ) return sc;
15
16 info() << "initialize" << endmsg;
17
18 for ( const auto& itr : m_pFilter.value() ) {
19 std::string fnc, lib;
20 parseFilter( itr, fnc, lib );
21 if ( !fnc.empty() ) m_filterfnc.insert( fnc );
22 if ( !lib.empty() ) m_filterlib.insert( lib );
23 }
24
25 return StatusCode::SUCCESS;
26 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:60
std::string::empty
T empty(T... args)
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
std::string
STL class.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:43
StatusCodeSvc::parseFilter
void parseFilter(const std::string &str, std::string &fnc, std::string &lib) const
Definition: StatusCodeSvc.cpp:141
std::set::insert
T insert(T... args)
StatusCodeSvc::m_pFilter
Gaudi::Property< std::vector< std::string > > m_pFilter
Definition: StatusCodeSvc.h:37
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:43

## ◆ list()

void StatusCodeSvc::list | ( |  | ) | const
| override

Definition at line 99 of file StatusCodeSvc.cpp.

99 {
100
101 std::ostringstream os;
102 unsigned int N = 0;
103
104 // Created a sorted map of the results
105 std::map<std::string, StatCodeDat> dat_sorted( m_dat.begin(), m_dat.end() );
106 for ( const auto& itr : dat_sorted ) {
107 const auto& dat = itr.second;
108
109 // we need to do this in case someone has gotten to regFnc before filters were setup in initialize
110 if ( failsFilter( dat.fnc, dat.lib ) ) continue;
111
112 N++;
113 os.width( 3 );
114 os.setf( std::ios_base::right, std::ios_base::adjustfield );
115 os << dat.count;
116
117 os << " | ";
118 os.width( 30 );
119 os.setf( std::ios_base::left, std::ios_base::adjustfield );
120 os << dat.fnc;
121
122 os << " | ";
123 os.setf( std::ios_base::left, std::ios_base::adjustfield );
124 os << dat.lib;
125
126 os << std::endl;
127 }
128 if ( N > 0 ) {
129 info() << "listing all unchecked return codes:" << endmsg;
130 info() << std::endl
131 << "Num | Function | Source Library" << std::endl
132 << "----+--------------------------------+------------------------------------------" << std::endl
133 << os.str() << endmsg;
134 } else {
135 if ( msgLevel( MSG::DEBUG ) ) debug() << "all StatusCode instances where checked" << endmsg;
136 }
137 }
std::ostringstream::setf
T setf(T... args)
MSG::DEBUG
Definition: IMessageSvc.h:15
std::endl
T endl(T... args)
StatusCodeSvc::failsFilter
bool failsFilter(const std::string &fnc, const std::string &lib) const
Definition: StatusCodeSvc.cpp:93
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
std::map
STL class.
CommonMessaging< implements< IService, IProperty, IStateful > >::msgLevel
MSG::Level msgLevel() const
get the cached level (originally extracted from the embedded MsgStream)
Definition: CommonMessaging.h:138
IOTest.N
int N
Definition: IOTest.py:99
std::ostringstream
STL class.
std::ostringstream::width
T width(T... args)
std::ostringstream::str
T str(T... args)
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
StatusCodeSvc::m_dat
tbb::concurrent_unordered_map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:42
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ parseFilter()

void StatusCodeSvc::parseFilter | ( | const std::string & | str,
|  | std::string & | fnc,
|  | std::string & | lib
| ) |  | const
| private

Definition at line 141 of file StatusCodeSvc.cpp.

141 {
142
143 auto loc = str.find( "=" );
144 if ( loc == std::string::npos ) {
145 fnc = str;
146 lib = "";
147 } else {
148 std::string key = str.substr( 0, loc );
149 std::string val = str.substr( loc + 1 );
150
151 toupper( key );
152
153 if ( key == "FCN" || key == "FNC" ) {
154 fnc = val;
155 lib.clear();
156 } else if ( key == "LIB" ) {
157 fnc.clear();
158 lib = val;
159 } else {
160 fnc.clear();
161 lib.clear();
162
163 warning() << "ignoring unknown token in Filter: " << str << endmsg;
164 }
165 }
166 }
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:101
std::string
STL class.
std::string::clear
T clear(T... args)
std::string::find
T find(T... args)
std::string::substr
T substr(T... args)
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:7
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ regFnc()

void StatusCodeSvc::regFnc | ( | const std::string & | func,
|  | const std::string & | lib
| ) |  |
| override

Definition at line 46 of file StatusCodeSvc.cpp.

46 {
47
48 if ( m_state == Gaudi::StateMachine::OFFLINE || m_state == Gaudi::StateMachine::CONFIGURED ) { return; }
49
50 // A StatusCode instance may be create internally by ROOT dictionaries and,
51 // of course, it's not checked, so here we whitelist a few library names
52 // that are known to produce spurious reports.
53 if ( m_dict ) {
54 // ROOT's library names can end with either ".so" or ".so.x.y" with x.y the ROOT version in use
55 const auto len = lib.length();
56 if ( len >= 3 && lib.compare( len - 3, 3, ".so" ) == 0 ) {
57 if ( ( len >= 7 && ( lib.compare( len - 7, 4, "Dict" ) == 0 || lib.compare( len - 7, 4, "Core" ) == 0 ) ) ||
58 ( len >= 8 && lib.compare( len - 8, 5, "Cling" ) == 0 ) ) {
59 return;
60 }
61 } else if ( lib.rfind( "Dict.so" ) != std::string::npos || lib.rfind( "Cling.so" ) != std::string::npos ||
62 lib.rfind( "Core.so" ) != std::string::npos ) {
63 return;
64 }
65 }
66 // this appears only with gcc 4.9...
67 if ( fnc == "_PyObject_GC_Malloc" ) return;
68 // GAUDI-1036
69 if ( fnc == "PyThread_get_thread_ident" ) return;
70 if ( fnc == "local" ) return;
71
72 const std::string rlib = lib.substr( lib.rfind( "/" ) + 1 );
73 if ( failsFilter( fnc, rlib ) ) return;
74
75 if ( m_abort ) {
76 fatal() << "Unchecked StatusCode in " << fnc << " from lib " << lib << endmsg;
77 msgStream().flush();
78 abort();
79 }
80
81 const std::string key = fnc + lib;
82
83 decltype( m_dat )::const_iterator itr = m_dat.find( key );
84 if ( itr != m_dat.end() ) {
85 ++( itr->second.count );
86 } else {
87 m_dat.emplace( key, StatCodeDat{fnc, rlib} );
88 }
89 }
Gaudi::StateMachine::CONFIGURED
Definition: StateMachine.h:14
Service::m_state
Gaudi::StateMachine::State m_state
Service state.
Definition: Service.h:153
StatusCodeSvc::m_dict
Gaudi::Property< bool > m_dict
Definition: StatusCodeSvc.h:40
std::string::rfind
T rfind(T... args)
StatusCodeSvc::failsFilter
bool failsFilter(const std::string &fnc, const std::string &lib) const
Definition: StatusCodeSvc.cpp:93
std::string
STL class.
MsgStream::flush
MsgStream & flush()
Definition: MsgStream.h:113
CommonMessagingBase::msgStream
MsgStream & msgStream() const
Return an uninitialized MsgStream.
Definition: CommonMessaging.h:71
StatusCodeSvc::m_dat
tbb::concurrent_unordered_map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:42
StatusCodeSvc::m_abort
Gaudi::Property< bool > m_abort
Definition: StatusCodeSvc.h:38
std::find
T find(T... args)
std::string::length
T length(T... args)
std::string::substr
T substr(T... args)
std::abort
T abort(T... args)
Gaudi::StateMachine::OFFLINE
Definition: StateMachine.h:13
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:92
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
std::string::compare
T compare(T... args)

## ◆ reinitialize()

StatusCode StatusCodeSvc::reinitialize | ( |  | ) |
| override

Definition at line 30 of file StatusCodeSvc.cpp.

30 {
31
32 info() << "reinitialize" << endmsg;
33
34 return StatusCode::SUCCESS;
35 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ suppressCheck()

bool StatusCodeSvc::suppressCheck | ( |  | ) | const
| inline override

Definition at line 21 of file StatusCodeSvc.h.

21 { return m_suppress.value(); }
StatusCodeSvc::m_suppress
Gaudi::Property< bool > m_suppress
Definition: StatusCodeSvc.h:39

## Member Data Documentation

## ◆ m_abort

Gaudi::Property<bool> StatusCodeSvc::m_abort {this, "AbortOnError", false}
| private

Definition at line 38 of file StatusCodeSvc.h.

## ◆ m_dat

tbb::concurrent_unordered_map<std::string, StatCodeDat> StatusCodeSvc::m_dat
| private

Definition at line 42 of file StatusCodeSvc.h.

## ◆ m_dict

Gaudi::Property<bool> StatusCodeSvc::m_dict {this, "IgnoreDicts", true}
| private

Definition at line 40 of file StatusCodeSvc.h.

## ◆ m_filterfnc

std::set<std::string> StatusCodeSvc::m_filterfnc
| private

Definition at line 43 of file StatusCodeSvc.h.

## ◆ m_filterlib

std::set<std::string> StatusCodeSvc::m_filterlib
| private

Definition at line 43 of file StatusCodeSvc.h.

## ◆ m_pFilter

Gaudi::Property<std::vector<std::string> > StatusCodeSvc::m_pFilter {this, "Filter"}
| private

Definition at line 37 of file StatusCodeSvc.h.

## ◆ m_suppress

Gaudi::Property<bool> StatusCodeSvc::m_suppress {this, "SuppressCheck", false}
| private

Definition at line 39 of file StatusCodeSvc.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/src/StatusCodeSvc.h
- GaudiCommonSvc/src/StatusCodeSvc.cpp